import sys
import os
import xmlrpclib
from inc_connect   import *
from tools import *

# Definition du proxy XML/RPC
oProxy=xmlrpclib.ServerProxy(sUrlZephir)

# Charge les prefixes locaux (Agents locaux)
oLocalPrefixes={}
if os.path.exists('./conf/local/scripts/local.py'):
    sys.path.append('./conf/local/scripts')
    from local import *

# Recuperation de l'Id du serveur
iId=sys.argv[1]
iReconfigureOld=sentinellestatus2zephir(sys.argv[2])
iNbPaquetEnMaj=sys.argv[3]
querymaj=iNbPaquetEnMaj

print "zeph_id,"+iId

# Get Agents status
oListStatus=convert(oProxy.serveurs.agents_status(iId)[1])
if ((type(oListStatus)== str) and (oListStatus.find('serveur inconnu')!=-1)):
     sys.exit(0)

# Recupere l'etat zephir
oListEtat=convert(oProxy.serveurs.get_status(iId)[1])

if oListEtat['timeout'][0] == 0:
    print "timeout,0"
    sys.exit(0)


iReconfigure=oListEtat['reconfigure_ok'][0]
iReconfigure=iReconfigureOld+1
if ((iReconfigure != iReconfigureOld ) or (iReconfigure == -2)):
	print '# RECUPERATION DE LA CONFIGURATION'
	print '# ========================================'

	oListVariables=convert(oProxy.serveurs.get_config(iId)[1])
	for variable in oListVariables:
		print 'conf_'+variable+','+cast(oListVariables[variable])

	print '# ========================================'


print '# RECUPERATION DE ETAT ZEPHIR'
print '# ========================================'
for etat in oListEtat:
	val=oListEtat[etat]
	if etat == "query_maj":
		querymaj=val
	if type(val) == list: 
		print etat + "," + str(oListEtat[etat][0])
	else:
		print etat + "," + str(val)
print '# ========================================'

#Recupere le status    
print '# ========================================'
print '# RECUPERATION DES STATUS'
for status in oListStatus:
    print status+","+str(oListStatus[status][1])
print '# ========================================'


oListParams=convert(oProxy.serveurs.get_serveur(iId)[1][0])
#Date du dernier log
oTime=eval(oListParams['params'])['last_log']
iTime=zephtime2seconds(oTime)
print "lastlog," + str(iTime)

iModuleActuel=oListParams['module_actuel']
sModuleName=convert(oProxy.modules.get_module(iModuleActuel)[1][0]['libelle'])
print 'modulename,'+sModuleName

print '# ========================================'
print '# RECUPERATION DES INFOS CONFIG ZEPHIR'
for info in oListParams:
        if info == 'params':
		continue
	print "zeph_"+info +","+cast(oListParams[info])

print '# ========================================'

L=convert(oProxy.serveurs.get_measure(iId)[1])
if L == '{}':
	sys.exit(0)


print '# ========================================'
print '# RECUPERATION DES MESURES'
# Liste des mesures
oList=eval(L)[int(iId)]


oDicPrefixes={"bacula":True}
for sPrefixe in oLocalPrefixes:
        oDicPrefixes[sPrefixe]=True


iUptime=oList['sysinfo']['uptime']

for status in oList:
    print '#STATUS:[' + str(status) + ']'
    sPrefixe=""
    if oDicPrefixes.has_key(str(status)):
        sPrefixe=status+"_"
 
    if type(oList[status]) == dict:
        o=oList[status]
        for info in o:
            s=o[info]
            #print info
            #print o[info]
        #print '#info:[' + info + '='+ o[info] +']'

            if type(o[info]) == int: s=str(o[info])
            if type(o[info]) == list:
                s=str(o[info][0])
            if type(o[info]) == dict:
                s="["+info+"]"
            if type(o[info]) == tuple: s=str(o[info]).replace(',','|')

            if  info == "load1" or  info == "load5" or info == "load15" :
                s=str(int(float(o[info])*100))

            # Ajout de l'uptime de la mesure
            if info.find('in_eth')!=-1 or info.find('out_eth')!=-1 or info.find('in_ipsec')!=-1 or info.find('out_ipsec')!=-1 :
                s=str(o[info]*1024)+"|"+str(iUptime)

            print sPrefixe+info + ","+s	


    if type(oList[status]) == list:
        print status+","+str(oList[status][0])
    if type(oList[status]) == int:
        print status+","+str(oList[status])



if iNbPaquetEnMaj != querymaj:
	print '# ========================================'
	print '# Liste des paquets en maj'
	oListeMaj=convert(oProxy.serveurs.get_maj_infos(iId)[1])
	sListe="paquets_maj,"
	for paquet in oListeMaj:
    		sListe+=paquet[0]+"|"
	print sListe


print '# ========================================'
