#!/bin/sh

. ./dbs.inc

OV=1
NV=`expr $OV + 1`

echo ""
echo "Script de migration de la base de la version $OV vers la version $NV"
if [ "$DBSVersion" != "$OV" ] ; then
	echo "Votre base n'est pas en version $OV"
	exit
fi

echo "Migration en cours"

echo -n "	-Creation de la base latest :"
	# Creation de la base
	F="CREATE DATABASE latest "
	$DBRoot "$F"
	# Mise en place des privilèges
	F="GRANT ALL PRIVILEGES ON latest.* TO 'sentinelle'@'localhost' WITH GRANT OPTION"
	$DBRoot "$F"
echo " OK"

echo  	"	-Deplacement des tables 'last' :"
	echo -n "		Sauvegarde   :     "
	# Récupérations de toutes les composantes
	TABLES=`$DBSentinelle "SELECT tag FROM composantes" `	
	COUNT=`echo $TABLES | wc -w 2>/dev/null`
	INDEX=0
	for TABLE in `echo $TABLES`; do
		T="last"$TABLE
		P=`expr $INDEX \* 100 / $COUNT`;P2=`align3 $P` ;echo -e -n "\b\b\b\b" ;echo  -n "$P2%"
		CMD="s/$T/$TABLE/g"
		mysqldump $ID  --complete-insert --no-create-info persistance $T 2>/dev/null | sed $CMD > /tmp/$TABLE.sql 2>/dev/null
		INDEX=`expr $INDEX + 1`
	done
	echo -e "\b\b\b\b OK "
	
	TABLES=`$DBSentinelle "SELECT tag,valeur FROM composantes" |  sed 's/\t/,/'`
	STRUCT="( rne VARCHAR(8) NOT NULL,srvkey VARCHAR(8) NOT NULL,offset SMALLINT NOT NULL DEFAULT 0,temps BIGINT(13) UNSIGNED NOT NULL,valeur "
	INDEX=0
	echo -n "		Restauration :     "	
	for LIGNE in `echo $TABLES`; do
		TABLE=`echo $LIGNE | cut -d, -f1`
		V=`echo $LIGNE | cut -d, -f2`
		TYPE="INT"
		if [ "$V" = "STRINGVALUE" ] ; then
			TYPE="VARCHAR(255)"
		fi
		if [ "$V" = "LARGEVALUE" ] ; then
		        TYPE="BIGINT(13)"
		fi

		P=`expr $INDEX \* 100 / $COUNT`;P2=`align3 $P` ;echo -e -n "\b\b\b\b" ;echo  -n "$P2%"
		
		# Création de la table
		F="CREATE TABLE $TABLE $STRUCT $TYPE )"
		$DBLatest "$F"	
		# Mise en place des index
		$DBLatest "ALTER TABLE $TABLE ADD UNIQUE ( rne,srvkey,offset)"	
		$DBLatest "ALTER TABLE $TABLE ADD PRIMARY KEY (rne,srvkey,offset)"
		
		mysql $ID latest < /tmp/$TABLE.sql

		$DBPersistance "DROP TABLE last$TABLE"

		INDEX=`expr $INDEX + 1`
	done

echo -e "\b\b\b\b OK "
echo  -n  "       -Modifications des tables :     "
		TABLES=`$DBSentinelle "SELECT tag,valeur FROM composantes" |  sed 's/\t/,/'`
		INDEX=0
	        for LIGNE in `echo $TABLES`; do
			TABLE=`echo $LIGNE | cut -d, -f1`
			V=`echo $LIGNE | cut -d, -f2`
			P=`expr $INDEX \* 100 / $COUNT`;P2=`align3 $P` ;echo -e -n "\b\b\b\b" ;echo  -n "$P2%"

			C=`$DBPersistance "SHOW COLUMNS FROM   $TABLE  LIKE 'offset'" | wc -l`
			if [ $C -eq 0 ] ; then
				F="ALTER TABLE $TABLE ADD offset SMALLINT NOT NULL DEFAULT 0  AFTER srvkey;"
				$DBPersistance "$F"
				$DBPersistance "ALTER TABLE $TABLE  DROP INDEX rne"	
				$DBPersistance "ALTER TABLE $TABLE  ADD UNIQUE ( rne,temps,srvkey,offset)"	
			fi
			INDEX=`expr $INDEX + 1`
		done
	

echo -e "\b\b\b\b OK "

$DBSentinelle "ALTER TABLE history CHANGE msg msg VARCHAR( 2048 ) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL"

$DBSentinelle "UPDATE variables set valeur='$NV' WHERE key='VERSION'"

echo "Migration éffectuée"




