# -*- coding: utf-8 -*-

import xmlrpclib
from inc_connect import *
from tools import *
import string
import sys
import cgi
import time
from random import *
from urllib2 import urlopen,quote


def getQuery(url,ville,cp,pays):
    query=quote(ville+' '+cp+', '+pays)
    query=url+query+"&output=csv&key="+GAPIKEY
    return query

def getGPS(GAPIKEY,url,ville,cp,pays):
    query=getQuery(url,ville,cp,pays)
    try:
        fh = urlopen(query)
        ret=fh.read()
        l=ret.split(',')
    except Exception, e:
        return None

    ret=[float(l[2]),float(l[3])]
    return ret

g=Random()


s_url="http://maps.google.com/maps/geo?q="

print ""
print " =========================================================="
print " Script de génération des coordonnées des établissements "
print " en fonction de leur adresse postale"
print ""
print " Pré-requis : "
print "    ° Munissez-vous de la clef GOOGLE API"
print "    ° Assurez-vous que les adresses postales des établissements"
print "         soient correctement renseignées sur zephir"
print "    ° Vous devez disposer d'un fond de carte (au moins 1500px de large)"
print "    ° Avoir repéré sur la carte au moins deux villes (si possible à deux "
print "          extrémités de la carte) avec leur coordonées X,Y"
print ""
print ""
print " =========================================================="

GAPIKEY=raw_input("Entrez votre clef Google API : ")
pays=raw_input("Pays : (Ex:France,Reunion,..) ")


print " ==================================================="
print "Veuillez renseigner les deux points de references "
print " ==================================================="

print "1er point"
oGPS=None
while oGPS == None:
    ville=raw_input("Ville/ Adresse :")
    oGPS=getGPS(GAPIKEY,s_url,ville,'',pays)
    if oGPS == [0,0]:
        print "Problème lors de la récupération des coordonnées "
        print "Essayez la requete suivante dans un navigateur"
        print "  "+getQuery(s_url,ville,'',pays)
        print "Et consulter le site GoogleMap pour plus d'infos" 
        print ""
        sys.exit(0)
    
    print "Coordonnees GPS de :"+ville+" ("+str(oGPS[0])+","+str(oGPS[1])+")"
    oGPS1=oGPS
oP=raw_input("Coordonnées x,y associées:")
oPXY1=[int(coord) for coord in oP.split(',')]


print ""
print "2eme point"
oGPS=None
while oGPS == None:
    ville=raw_input("Ville/ Adresse :")
    oGPS=getGPS(GAPIKEY,s_url,ville,'',pays)
    print "Coordonnees GPS de :"+ville+" ("+str(oGPS[0])+","+str(oGPS[1])+")"
    oGPS2=oGPS
oP=raw_input("Coordonnées x,y associées :")
oPXY2=[int(coord) for coord in oP.split(',')]

lat_width=abs(oGPS2[0]-oGPS1[0])
long_width=abs(oGPS2[1]-oGPS1[1])

iPXY_width=abs(oPXY2[0]-oPXY1[0])
iPXY_height=abs(oPXY2[1]-oPXY1[1])

print " Récupération des coordonnées GPS "
f2=open('/etc/sentinelle/client/_client/etabs.txt','w')

oProxy=xmlrpclib.ServerProxy(sUrlZephir)
etabs=convert(oProxy.etabs.get_etab()[1])
cpc=2
if pays.lower() != "france":
      cpc=5

oMap={}
for etab in etabs:
    etab['ville']= etab['ville'].upper().replace("CEDEX","").strip()
    rne= etab['rne']
    ville=etab['ville']
    nom=etab['libelle']
    
    loc=etab['adresse']+ ' ' + etab['ville']+' '+etab['cp'][:cpc]+', '+pays
    time.sleep(1)
    query=s_url+quote(loc)+"&output=csv&key="+GAPIKEY
    try:
        fh = urlopen(query)
        ret=fh.read()
        l=ret.split(',')
        
    except Exception, e:
        print e
        l=[0,0,0,0]
    

    Lat=float(l[2])
    Lon=float(l[3])

    if Lat==0 and Lon==0:
        x=-1
        y=-1
    else:
        x=(int)(((Lon-oGPS1[1])*iPXY_width)/long_width + oPXY1[0])
        y=(int)(-((Lat-oGPS1[0])*iPXY_height)/lat_width + oPXY1[1])

    sCoor=str(x)+","+str(y)
    if oMap.has_key(sCoor):
          print "-> Random coordonnées pour "+rne
          x=x+g.randrange(-200,200)
          y=y+g.randrange(-200,200)

    sCoor=str(x)+","+str(y)
    oMap[sCoor]=1

    ligne=rne+","+nom+","+str(x)+","+str(y)+","+str(Lon)+","+str(Lat)+","+ville
    print rne+":"+nom+":"+loc+" = ("+str(x)+","+str(y)+")"
    if x==-1 and y==-1:
        print "-> Erreur lors de la récupération de "+rne+":"+nom

    f2.write(ligne+"\n")


f2.close()
